<template>
  <div id="app">
    <div id="map" />
    <input
      v-model="scaleReference"
      type="text"
    >m.
    <hr>
    Distance: {{ distance | readableLength }}
    Scale: {{ scale }}
  </div>
</template>

<script>
import MapImage from './assets/map.png'

import { getCenter } from 'ol/extent'
import Projection from 'ol/proj/Projection'
import VectorSource from 'ol/source/Vector'
import VectorLayer from 'ol/layer/Vector'
import StaticSource from 'ol/source/ImageStatic'
import ImageLayer from 'ol/layer/Image'
import Map from 'ol/Map'
import View from 'ol/View'

// Measurements
import DrawInteraction from 'ol/interaction/Draw'
import { getDistance } from 'ol/sphere'
import { unByKey } from 'ol/Observable'
import { Style, Fill, Stroke, Circle as CircleStyle } from 'ol/style'
import { ScaleLine } from 'ol/control'

export default {
  name: 'App',
  components: {},
  filters: {
    readableLength (length) {
      let output
      if (length > 100) {
        output = Math.round((length / 1000) * 100) / 100 + ' ' + 'km'
      } else {
        output = Math.round(length * 100) / 100 + ' ' + 'm'
      }
      return output
    },
  },
  data () {
    return {
      scaleReference: 1,
      imageSize: [1377, 1944],
      previousScale: 1 / 100000,
      points: [],
      map: null,
      imageLayer: null,
    }
  },
  computed: {
    distance () {
      if (this.points.length < 2) return 0

      return getDistance(this.points[0], this.points[1])
    },
    scale () { return this.scaleReference / this.distance },
  },
  created () {
    this.$nextTick(() => {
      this.createMap()
      this.enterMeasureMode()
    })
  },
  methods: {
    scaleExtent (scale = 1) {
      const baseScale = this.previousScale * scale
      this.previousScale = baseScale
      return [0, 0, this.imageSize[0] * baseScale, this.imageSize[1] * baseScale]
    },
    imageLayerSource (projection, extent) {
      return new StaticSource({
        url: `./${MapImage}`,
        projection,
        imageExtent: extent,
      })
    },
    createMap () {
      const extent = this.scaleExtent()
      const imageCenter = getCenter(extent)

      const projection = new Projection({
        code: 'EPSG:4326',
        unit: 'meter',
        extent,
      })

      const imageSource = this.imageLayerSource(projection, extent)
      const imageLayer = new ImageLayer({ source: imageSource })
      this.imageLayer = imageLayer

      const view = new View({
        projection,
        center: imageCenter,
        resolution: 1,
        zoom: 2,
        maxZoom: 12,
      })

      this.map = new Map({
        target: 'map',
        layers: [imageLayer],
        view,
      })

      this.map.addControl(new ScaleLine({ units: 'metric' }))
    },
    enterMeasureMode () {
      const source = new VectorSource({})
      const layer = new VectorLayer({ source })
      let points = []
      let features = []
      const that = this

      this.map.addLayer(layer)

      const style = new Style({
        fill: new Fill({
          color: 'rgba(255, 255, 255, 0.2)',
        }),
        stroke: new Stroke({
          color: 'rgba(0, 0, 0, 0.5)',
          lineDash: [10, 10],
          width: 2,
        }),
        image: new CircleStyle({
          radius: 5,
          stroke: new Stroke({
            color: 'rgba(0, 0, 0, 0.7)',
          }),
          fill: new Fill({
            color: 'rgba(255, 255, 255, 0.2)',
          }),
        }),
      })

      const interaction = new DrawInteraction({
        source,
        type: 'Point',
        style,
      })
      this.map.addInteraction(interaction)

      let listener

      interaction.on('drawend', function (event) {
        points.push(event.feature.getGeometry().flatCoordinates)
        event.feature.setStyle(style)
        features.push(event.feature)
        unByKey(listener)

        if (points.length === 2) {
          that.$nextTick(() => {
            source.getFeatures().forEach(f => { source.removeFeature(f) })
          })
          that.updateScale(points)
          points = []
          features = []
        }
      })
    },
    updateScale (points) {
      this.points = points
      const view = this.map.getView()
      const newExtent = this.scaleExtent(this.scale)
      console.log(newExtent)
      this.imageLayer.setSource(this.imageLayerSource(view.getProjection(), newExtent))

      view.fit(newExtent, this.map.getSize())
    },
  },
}
</script>

<style lang="scss">
* {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}

@import "~ol/ol.css";

#map {
  width: 100%;
  height: 800px;
  border: 3px solid red;
}
</style>
